use std::sync::Mutex;
use std::thread;

const NUM_THREADS: usize = 10;
const INCREMENTS_PER_THREAD: usize = 10000;

fn foo(x: &u32) -> &u32 {
    x
}

fn main() {
    let mut counter = Mutex::new(0);
    let mut handles = vec![];
    for _ in 0..NUM_THREADS {
        let handle = thread::spawn(|| {
            for _ in 0..INCREMENTS_PER_THREAD {
                *counter.lock().unwrap() += 1;
            }
        });
        handles.push(handle);
    }

    for handle in handles {
        handle.join().unwrap();
    }

    println!("Final counter value: {}", counter.lock().unwrap());
}

