use std::sync::{Arc,Mutex};
use std::thread;

const NUM_THREADS: usize = 10;
const INCREMENTS_PER_THREAD: usize = 10000;

fn main() {
    // Arc
    let counter = Arc::new(0);
    let mut handles = vec![];
    for _ in 0..NUM_THREADS {
        // clone
        let counter = Arc::clone(&counter);
        // move
        let handle = thread::spawn(move || {
            for _ in 0..INCREMENTS_PER_THREAD {
                *counter += 1;
            }
        });
        handles.push(handle);
    }

    for handle in handles {
        handle.join().unwrap();
    }

    println!("Final counter value: {}", *counter);
}
