use std::sync::{Arc,Mutex};
use std::thread;

const NUM_THREADS: usize = 10;
const INCREMENTS_PER_THREAD: usize = 10000;

fn main() {
    let counter = Arc::new(Mutex::new(0));
    let mut handles = vec![];
    for _ in 0..NUM_THREADS {
        let counter = Arc::clone(&counter);
        let handle = thread::spawn(move || {
            for _ in 0..INCREMENTS_PER_THREAD {
                let guard = counter.lock().unwrap();
                *guard += 1;
            }
        });
        handles.push(handle);
    }
    for handle in handles {
        handle.join().unwrap();
    }
    println!("Counter: {}", counter.lock().unwrap());
}
