use std::sync::{Arc,Mutex};
use std::thread;
use std::rc::Rc;
use std::cell::RefCell;

const NUM_THREADS: usize = 10;
const INCREMENTS_PER_THREAD: usize = 10000;

fn main() {
    let counter = Rc::new(RefCell::new(0));
    let mut handles = vec![];
    for _ in 0..NUM_THREADS {
        let counter = Rc::clone(&counter);
        let handle = thread::spawn(move || {
            for _ in 0..INCREMENTS_PER_THREAD {
                *counter.borrow_mut() += 1;
            }
        });
        handles.push(handle);
    }
    for handle in handles {
        handle.join().unwrap();
    }
    println!("Counter: {}", counter.borrow_mut());
}
